/*
Cr par Eric Dodji Gbofu
Email: dodericg@yahoo.fr
Twitter: @doderic
Blog: http://doderic.wordpress.com
Site: http://www.yatasoft.com
Dcembre 2011
*/

#include "mainwindow.h"
#include <fstream>
#include <QDesktopServices>
#include <QUrl>
#include <QFileDialog>
#include <QDir>
#include <QFile>
#include <QFileInfo>
#include <QXmlStreamWriter>
#include <QXmlStreamReader>
#include "propbool.h"
#include "propnum.h"
#include "proppos.h"
#include "proptypeslide.h"
#include "contenusslide.h"

//using namespace std;

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
{
    setFixedSize(850,700);

    ui=new Ui::MainWindow();
    ui->setupUi(this);

    //ui->previewWebView->load(QUrl("default_accueil.html"));
    ui->previewWebView->load(QUrl("default.html"));

    propbool=new PropBool();
    propnum=new PropNum();
    proppos=new PropPos();
    proptypeslide=new PropTypeSlide();
    contslides=new ContenusSlide();
    ui_dialog_code_a_copier=new CodeACopier(this);

    connect(ui->actionQuitter,SIGNAL(triggered()),qApp,SLOT(quit()));
    connect(ui->actionA_propos,SIGNAL(triggered()),this,SLOT(a_propos()));
    connect(ui->actionA_propos_de_Coda_slider,SIGNAL(triggered()),this,SLOT(a_propos_codaslider()));
    connect(ui->actionTester_avec_le_navigateur,SIGNAL(triggered()),this,SLOT(test_dans_navigateur()));
    connect(ui->exportanimation,SIGNAL(clicked()),this,SLOT(export_animation()));
    connect(ui->actionExporter_l_animation,SIGNAL(triggered()),this,SLOT(export_animation()));
    connect(ui->actionLe_site_web_de_SlideAlways,SIGNAL(triggered()),this,SLOT(lancer_site_de_slidealways()));
    connect(ui->actionEnregistrer_le_projet_sous,SIGNAL(triggered()),this,SLOT(enregistrer_projet_sous()));
    connect(ui->actionOuvrir_un_projet,SIGNAL(triggered()),this,SLOT(ouvrir_projet()));
    connect(ui->actionCopier_le_code_ins_rer,SIGNAL(triggered()),this,SLOT(on_copier_code_insert_clicked()));
    connect(ui->actionEnregi_strer,SIGNAL(triggered()),this,SLOT(enregistrer_projet()));

}

MainWindow::~MainWindow()
{
    delete propbool;
    delete propnum;
    delete proppos;
    delete proptypeslide;
    delete contslides;
    //pas besoin de le dtruire manuellement. Etant donn que je l'ai parent
    // la fenetre principale alors sa destruction causera aussi la destruction de cette fenetre
    //delete ui_dialog_code_a_copier;
    delete ui;

}

void MainWindow::a_propos()
{
    QMessageBox::about(this,"A propos de SlideAlways","<h2>YATASOFT</h2>"
                       "<u>Site web:</u> http://www.yatasoft.com"
                       "<br><u>Fil Twitter:</u> @yatasoftg"
                       "<p><b>Programm par Eric Dodji Gbofu</b>"
                       "<br><u>E-mail:</u> dodericg@yahoo.fr - <u>Twitter:</u> @doderic"
                       "<p><b>Copyright 2011</b>"
                       "<p>Cette Version 1.0 de SlideAlways est une VERSION GRATUITE."
                       );
}

void MainWindow::a_propos_codaslider()
{
    QMessageBox::about(this,"A propos de Coda Slider","<h3>Coda Slider</h3>"
                       "Coda slider est un plugin Jquery sous licence MIT et GPL."
                       "Il a t programm par Niall Doherty et est fortement inspir du slider Panic Cola."
                       "Il permet de prsenter n'importe quel contenu HTML sous la forme d'un slider."
                       "<p><u>Site web:</u> http://www.ndoherty.biz"
                       );
}

void MainWindow::on_test_navigateur_clicked()
{
    test_dans_navigateur();
}

void MainWindow::test_dans_navigateur()
{
    QDesktopServices::openUrl(QUrl("default.html"));

}

void MainWindow::lancer_site_de_slidealways()
{
    QDesktopServices::openUrl(QUrl("http://www.yatasoft.com"));

}

void MainWindow::lancer_preview(){
    //ui->previewWebView->setUrl(QUrl("default.html"));
    ui->previewWebView->reload();
}

void MainWindow::enregistrement_fichier(string contenu)
{
    string nom_fichier_complet="default.html";
    ofstream out(nom_fichier_complet.c_str());
    out<<contenu;
    out.close();

}

void MainWindow::enregistrement_projet(QString nomFichier)
{
    QString choix_slide_s;
    QString choix_fleche_s;
    QString choix_tabsdyn_s;
    QString choix_autoheight_s;
    QString choix_tabsauto_s;
    QString choix_crosslinking_s;
    QString choix_slidestoponclic_s;


    QString val_duree_anim_s;
    QString val_premier_slide_s;
    QString val_slide_interval_s;
    QString val_duree_anim_hauteur_s;

    recuperation_etat_proprietes();


    if(choix_slide==true){
        choix_slide_s="true";
    } else if(choix_slide==false){
        choix_slide_s="false";
    }
//--------------------------------
    if(choix_fleche==true){
        choix_fleche_s="true";
    } else if(choix_fleche==false){
        choix_fleche_s="false";
    }
//--------------------------------
    if(choix_tabsdyn==true){
        choix_tabsdyn_s="true";
    } else if(choix_tabsdyn==false){
        choix_tabsdyn_s="false";
    }
//--------------------------------
    if(choix_autoheight==true){
        choix_autoheight_s="true";
    } else if(choix_autoheight==false){
        choix_autoheight_s="false";
    }
//--------------------------------
    if(choix_tabsauto==true){
        choix_tabsauto_s="true";
    } else if(choix_tabsauto==false){
        choix_tabsauto_s="false";
    }
 //----------------------------------
    if(choix_crosslinking==true){
        choix_crosslinking_s="true";
    } else if(choix_crosslinking==false){
        choix_crosslinking_s="false";
    }
   //----------------------------------
    if(choix_slidestoponclic==true){
        choix_slidestoponclic_s="true";
    } else if(choix_slidestoponclic==false){
        choix_slidestoponclic_s="false";
    }

//--------------Pour les variables numriques----------------------

    val_duree_anim_s.setNum(val_duree_anim);
    val_premier_slide_s.setNum(val_premier_slide);;
    val_slide_interval_s.setNum(val_slide_interval);;
    val_duree_anim_hauteur_s.setNum(val_duree_anim_hauteur);;


    if(!nomFichier.isEmpty()){
        QFile fichier(fichier_courant);
        fichier.open(QIODevice::WriteOnly);

        QXmlStreamWriter stream(&fichier);
        stream.setAutoFormatting(true);
        stream.writeStartDocument();
        stream.writeComment("Gnr par SlideAlways.");
        stream.writeComment("Yatasoft - Site: www.yatasoft.com, Twitter: @yatasoftg, Mail: dodericg@yahoo.fr");

        stream.writeStartElement("slidealways");

        stream.writeStartElement("propbool");
        stream.writeTextElement("autoslide", choix_slide_s);
        stream.writeTextElement("dynamicsarrow", choix_fleche_s);
        stream.writeTextElement("dynamicstabs", choix_tabsdyn_s);
        stream.writeTextElement("autoheight", choix_autoheight_s);
        stream.writeTextElement("tabsauto", choix_tabsauto_s);
        stream.writeTextElement("crosslinking", choix_crosslinking_s);
        stream.writeTextElement("slidestoponclic", choix_slidestoponclic_s);
        stream.writeEndElement(); // fin propbool

        stream.writeStartElement("propnum");
        stream.writeTextElement("dureeanimslide", val_duree_anim_s);
        stream.writeTextElement("premier_slide", val_premier_slide_s);
        stream.writeTextElement("slideinterval", val_slide_interval_s);
        stream.writeTextElement("dureeanimhauteur", val_duree_anim_hauteur_s);
        stream.writeEndElement(); // fin propnum

        stream.writeStartElement("proppos");
        stream.writeTextElement("texteflechegauche", val_texte_fleche_gauche);
        stream.writeTextElement("texteflechedroite", val_texte_fleche_droite);
        stream.writeTextElement("textetabsalign", val_texte_tabs_align);
        stream.writeTextElement("textetabsposition", val_texte_tabs_position);
        stream.writeEndElement(); // fin proppos

        stream.writeStartElement("proptypeslide");
        stream.writeTextElement("typeanimhauteur", val_type_anim_hauteur);
        stream.writeTextElement("typeanimtransition", val_type_anim_transition);
        stream.writeEndElement(); // fin proptypeslide

        stream.writeStartElement("titrepanel");
        stream.writeTextElement("titrepanel1", titre1);
        stream.writeTextElement("titrepanel2", titre2);
        stream.writeTextElement("titrepanel3", titre3);
        stream.writeTextElement("titrepanel4", titre4);
        stream.writeEndElement(); // fin titrepanel

        stream.writeStartElement("contenupanel");
        if(ui->lineEditImg1->text().length()!=0){
            contenu1=ui->lineEditImg1->text();
        }
        if(ui->lineEditImg2->text().length()!=0){
            contenu2=ui->lineEditImg2->text();
        }
        if(ui->lineEditImg3->text().length()!=0){
            contenu3=ui->lineEditImg3->text();
        }
        if(ui->lineEditImg4->text().length()!=0){
            contenu4=ui->lineEditImg4->text();
        }
        stream.writeTextElement("contenupanel1", contenu1);
        stream.writeTextElement("contenupanel2", contenu2);
        stream.writeTextElement("contenupanel3", contenu3);
        stream.writeTextElement("contenupanel4", contenu4);
        stream.writeEndElement(); // fin contenupanel

        stream.writeEndElement(); // fin slidealways

        stream.writeEndDocument();

}

}

void MainWindow::enregistrer_projet()
{
    if(fichier_courant.isEmpty()){
        enregistrer_projet_sous();

        QString titre;
        titre.sprintf("SlideAlways - %s",fichier_courant.toStdString().data());

        setWindowTitle(titre);
    } else {
        enregistrement_projet(fichier_courant);

        QString titre;
        titre.sprintf("SlideAlways - %s",fichier_courant.toStdString().data());

        setWindowTitle(titre);
    }
}

void MainWindow::enregistrer_projet_sous()
{

    QString nom_fichier=QFileDialog::getSaveFileName(this,tr("Enregistrer le projet sous"),".",tr("Fichiers SlideAlways (*.slide)"));
    fichier_courant=nom_fichier;

    if(!nom_fichier.isEmpty()){
        enregistrement_projet(nom_fichier);

        QString titre;
        titre.sprintf("SlideAlways - %s",nom_fichier.toStdString().data());

        setWindowTitle(titre);
    }

}

void MainWindow::ouvrir_projet()
{
    QString nom_fichier=QFileDialog::getOpenFileName(this,tr("Ouvrir un projet"),".",tr("Fichiers SlideAlways (*.slide)"));

    if(!nom_fichier.isEmpty()){

        QString cont; //Rcupration du contenu des tags en texte
        bool cont_bool=false; //Rcupration du contenu des tags boolens
        int cont_int=0; //Rcupration du contenu des tags numriques

        QString titre;
        titre.sprintf("SlideAlways - %s",nom_fichier.toStdString().data());
        setWindowTitle(titre);


        QFile fichier(nom_fichier);
        fichier.open(QIODevice::ReadOnly);

        QXmlStreamReader stream(&fichier);

        while(!stream.atEnd()){

            if(stream.readNextStartElement())
            {
                if(stream.name()=="autoslide"){
                    cont=stream.readElementText();
                    //bool cont_bool=false;
                    if(cont=="true")
                        cont_bool=true;
                    else if(cont=="false")
                        cont_bool=false;

                    ui->autoslide->setChecked(cont_bool);

                } else if(stream.name()=="dynamicsarrow"){
                    cont=stream.readElementText();
                    //bool cont_bool=false;
                    if(cont=="true")
                        cont_bool=true;
                    else if(cont=="false")
                        cont_bool=false;

                    ui->defil_fleche->setChecked(cont_bool);

                } else if(stream.name()=="dynamicstabs"){
                    cont=stream.readElementText();
                    //bool cont_bool=false;
                    if(cont=="true")
                        cont_bool=true;
                    else if(cont=="false")
                        cont_bool=false;

                    ui->tabsdyn->setChecked(cont_bool);

                } else if(stream.name()=="autoheight"){
                    cont=stream.readElementText();
                    //bool cont_bool=false;
                    if(cont=="true")
                        cont_bool=true;
                    else if(cont=="false")
                        cont_bool=false;

                    ui->autoheight->setChecked(cont_bool);

                } else if(stream.name()=="tabsauto"){
                    cont=stream.readElementText();
                    //bool cont_bool=false;
                    if(cont=="true")
                        cont_bool=true;
                    else if(cont=="false")
                        cont_bool=false;

                    ui->tabsdyn->setChecked(cont_bool);

                } else if(stream.name()=="crosslinking"){
                    cont=stream.readElementText();
                    //bool cont_bool=false;
                    if(cont=="true")
                        cont_bool=true;
                    else if(cont=="false")
                        cont_bool=false;

                    ui->crosslinking->setChecked(cont_bool);

                } else if(stream.name()=="slidestoponclic"){
                    cont=stream.readElementText();
                    //bool cont_bool=false;
                    if(cont=="true")
                        cont_bool=true;
                    else if(cont=="false")
                        cont_bool=false;

                    ui->stopslideonclic->setChecked(cont_bool);

                } else if(stream.name()=="dureeanimslide"){        // dbut de lecture des proprits numriques
                    cont=stream.readElementText();
                    //int cont_int=0;
                    if(!cont.isEmpty()){
                        cont_int=cont.toInt();
                        ui->dureeanim->setValue(cont_int);
                    }

                } else if(stream.name()=="premier_slide"){
                    cont=stream.readElementText();
                    //int cont_int=0;
                    if(!cont.isEmpty()){
                        cont_int=cont.toInt();
                        ui->firstslide->setValue(cont_int);
                    }

                } else if(stream.name()=="slideinterval"){
                    cont=stream.readElementText();
                    //int cont_int=0;
                    if(!cont.isEmpty()){
                        cont_int=cont.toInt();
                        ui->slideinterval->setValue(cont_int);
                    }

                } else if(stream.name()=="dureeanimhauteur"){
                    cont=stream.readElementText();
                    //int cont_int=0;
                    if(!cont.isEmpty()){
                        cont_int=cont.toInt();
                        ui->dureeanimhauteur->setValue(cont_int);
                    }

                } else if(stream.name()=="texteflechegauche"){  // dbut de lecture des proprits de positionnement
                    cont=stream.readElementText();

                    if(!cont.isEmpty()){
                        ui->lefttext->setText(cont);
                    }

                } else if(stream.name()=="texteflechedroite"){
                    cont=stream.readElementText();

                    if(!cont.isEmpty()){
                        ui->righttext->setText(cont);
                    }

                } else if(stream.name()=="textetabsalign"){
                    cont=stream.readElementText();

                    if(!cont.isEmpty()){
                        ui->poshorizontale->setItemText(0,cont);

                    }

                } else if(stream.name()=="textetabsposition"){
                    cont=stream.readElementText();

                    if(!cont.isEmpty()){
                        ui->posverticale->setItemText(0,cont);

                    }

                } else if(stream.name()=="typeanimhauteur"){       //dbut de lecture des proprits du type de slide
                    cont=stream.readElementText();

                    if(!cont.isEmpty()){
                        ui->typeanimhauteur->setItemText(0,cont);

                    }

                } else if(stream.name()=="typeanimtransition"){
                    cont=stream.readElementText();

                    if(!cont.isEmpty()){
                        ui->transitionslides->setItemText(0,cont);

                    }

                } else if(stream.name()=="titrepanel1"){
                    cont=stream.readElementText();

                    if(!cont.isEmpty()){
                        ui->titrepanel1->setText(cont);

                    }

                } else if(stream.name()=="titrepanel2"){
                    cont=stream.readElementText();

                    if(!cont.isEmpty()){
                        ui->titrepanel2->setText(cont);

                    }

                } else if(stream.name()=="titrepanel3"){
                    cont=stream.readElementText();

                    if(!cont.isEmpty()){
                        ui->titrepanel3->setText(cont);

                    }

                } else if(stream.name()=="titrepanel4"){
                    cont=stream.readElementText();

                    if(!cont.isEmpty()){
                        ui->titrepanel4->setText(cont);

                    }

                } else if(stream.name()=="contenupanel1"){
                    cont=stream.readElementText();

                    if(!cont.isEmpty()){
                        if(cont.contains('/',Qt::CaseInsensitive)==true){
                            ui->lineEditImg1->setText(cont);
                        } else {
                            ui->contenupanel1->setPlainText(cont);
                        }

                    }

                } else if(stream.name()=="contenupanel2"){
                    cont=stream.readElementText();

                    if(!cont.isEmpty()){
                        if(cont.contains('/',Qt::CaseInsensitive)==true){
                            ui->lineEditImg2->setText(cont);
                        } else {
                            ui->contenupanel2->setPlainText(cont);
                        }

                    }

                } else if(stream.name()=="contenupanel3"){
                    cont=stream.readElementText();

                    if(!cont.isEmpty()){
                        if(cont.contains('/',Qt::CaseInsensitive)==true){
                            ui->lineEditImg3->setText(cont);
                        } else {
                            ui->contenupanel3->setPlainText(cont);
                        }

                    }

                } else if(stream.name()=="contenupanel4"){
                    cont=stream.readElementText();

                    if(!cont.isEmpty()){
                        if(cont.contains('/',Qt::CaseInsensitive)==true){
                            ui->lineEditImg4->setText(cont);
                        } else {
                            ui->contenupanel4->setPlainText(cont);
                        }

                    }

                }


            }


        }

    }

}

void MainWindow::export_animation()
{
    QString nom_dossier_sauvegarde=QFileDialog::getExistingDirectory(this,tr("Choisir un dossier"),".",QFileDialog::ShowDirsOnly);


    if(!nom_dossier_sauvegarde.isEmpty()){
        string nom_dossier_complet=nom_dossier_sauvegarde.toStdString()+"/index.html";
        ofstream out(nom_dossier_complet.c_str());

        ifstream in("default.html");
        string contenu;

        while(getline(in,contenu)){
            out<<contenu+"\n";
        }
        in.close();
        out.close();
//----------------Cration du dossier "stylesheets"  l'emplacement de sauvegarde de l'utilisateur----------------
         QDir dir_stylesheets;
         dir_stylesheets.mkdir(nom_dossier_sauvegarde+"/stylesheets");
         QString chemin_stylesheets=nom_dossier_sauvegarde+"/stylesheets";

//----------------Exportation du fichier "coda-slider-2.0.css"----------------
         QString fichier=chemin_stylesheets+"/coda-slider-2.0.css";
         ofstream out_codacss1(fichier.toStdString().c_str());

         ifstream in_codacss1("stylesheets/coda-slider-2.0.css");
         string contenu_codacss;

         while(getline(in_codacss1,contenu_codacss)){
             out_codacss1<<contenu_codacss+"\n";
         }
         out_codacss1.close();
         in_codacss1.close();
//----------------Exportation du fichier "reset.css"----------------
         fichier=chemin_stylesheets+"/reset.css";
         ofstream out_codacss2(fichier.toStdString().c_str());

         ifstream in_codacss2("stylesheets/reset.css");
         //string contenu_codacss1;

         while(getline(in_codacss2,contenu_codacss)){
             out_codacss2<<contenu_codacss+"\n";
         }
         out_codacss2.close();
         in_codacss2.close();


//----------------Cration du dossier "javascripts"  l'emplacement de sauvegarde de l'utilisateur----------------
         QDir dir_javascripts;
         dir_javascripts.mkdir(nom_dossier_sauvegarde+"/javascripts");
         QString chemin_javascripts=nom_dossier_sauvegarde+"/javascripts";

//----------------Exportation du fichier "jquery-1.3.2.min.js"-----------------------
         fichier=chemin_javascripts+"/jquery-1.3.2.min.js";
         ofstream out_codaj1(fichier.toStdString().c_str());

         ifstream in_codaj1("javascripts/jquery-1.3.2.min.js");
          string contenu_codajs;

         while(getline(in_codaj1,contenu_codajs)){
              out_codaj1<<contenu_codajs+"\n";
         }
         out_codaj1.close();
         in_codaj1.close();
//----------------Exportation du fichier "jquery.coda-slider-2.0.js"-----------------------
         fichier=chemin_javascripts+"/jquery.coda-slider-2.0.js";
         ofstream out_codaj2(fichier.toStdString().c_str());

         ifstream in_codaj2("javascripts/jquery.coda-slider-2.0.js");
         //string contenu_codajs;

         while(getline(in_codaj2,contenu_codajs)){
               out_codaj2<<contenu_codajs+"\n";
         }
         out_codaj2.close();
         in_codaj2.close();
//----------------Exportation du fichier "jquery.easing.1.3.js"-----------------------
         fichier=chemin_javascripts+"/jquery.easing.1.3.js";
         ofstream out_codaj3(fichier.toStdString().c_str());

         ifstream in_codaj3("javascripts/jquery.easing.1.3.js");
         //string contenu_codajs;

         while(getline(in_codaj3,contenu_codajs)){
                out_codaj3<<contenu_codajs+"\n";
         }
         out_codaj3.close();
         in_codaj3.close();

    }
}

//---------Rcupration des tats des proprits---------------
void MainWindow::recuperation_etat_proprietes(){


    choix_slide=ui->autoslide->isChecked();
    choix_fleche=ui->defil_fleche->isChecked();
    choix_tabsdyn=ui->tabsdyn->isChecked();
    choix_autoheight=ui->autoheight->isChecked();
    choix_tabsauto=ui->tabsdyn->isChecked();
    choix_crosslinking=ui->crosslinking->isChecked();
    choix_slidestoponclic=ui->stopslideonclic->isChecked();

    val_duree_anim=ui->dureeanim->value();
    val_premier_slide=ui->firstslide->value();
    val_slide_interval=ui->slideinterval->value();
    val_duree_anim_hauteur=ui->dureeanimhauteur->value();

    val_texte_fleche_gauche=ui->lefttext->text();
    val_texte_fleche_droite=ui->righttext->text();
    val_texte_tabs_align=ui->poshorizontale->currentText();
    val_texte_tabs_position=ui->posverticale->currentText();

    val_type_anim_hauteur=ui->typeanimhauteur->currentText();
    val_type_anim_transition=ui->transitionslides->currentText();

    QString titre_contenu_partiel;

    titre_contenu_partiel=ui->titrepanel1->text();
    titre_contenu_partiel=titre_contenu_partiel.replace("","&eacute;");
    titre_contenu_partiel=titre_contenu_partiel.replace("","&egrave;");
    titre1=titre_contenu_partiel.replace("","&agrave;").toUtf8();

    titre_contenu_partiel=ui->titrepanel2->text();
    titre_contenu_partiel=titre_contenu_partiel.replace("","&eacute;");
    titre_contenu_partiel=titre_contenu_partiel.replace("","&egrave;");
    titre2=titre_contenu_partiel.replace("","&agrave;").toUtf8();

    titre_contenu_partiel=ui->titrepanel3->text();
    titre_contenu_partiel=titre_contenu_partiel.replace("","&eacute;");
    titre_contenu_partiel=titre_contenu_partiel.replace("","&egrave;");
    titre3=titre_contenu_partiel.replace("","&agrave;").toUtf8();

    titre_contenu_partiel=ui->titrepanel4->text();
    titre_contenu_partiel=titre_contenu_partiel.replace("","&eacute;");
    titre_contenu_partiel=titre_contenu_partiel.replace("","&egrave;");
    titre4=titre_contenu_partiel.replace("","&agrave;").toUtf8();

    if(ui->radioTxt1->isChecked()){
        titre_contenu_partiel=ui->contenupanel1->toPlainText();
        titre_contenu_partiel=titre_contenu_partiel.replace("","&eacute;");
        titre_contenu_partiel=titre_contenu_partiel.replace("","&egrave;");
        contenu1=titre_contenu_partiel.replace("","&agrave;").toUtf8();
    } else if(ui->radioImg1->isChecked()){

            QFileInfo infos(ui->lineEditImg1->text());
            contenu1="<div align='center'><img src='"+infos.fileName()+"'></div>";

            QFile sourceFile(ui->lineEditImg1->text());
            sourceFile.open(QIODevice::ReadOnly);

            QFile destFile(infos.fileName());
            destFile.open(QIODevice::WriteOnly);

            destFile.write(sourceFile.readAll());
            sourceFile.close();
            destFile.close();

    }



//    if(contenu1.length()>1008){
//        QMessageBox::warning(this,"Dpassement de la limite","Le contenu du Panel dpasse 1000 caractres. Veuillez le diminuer");
//        return;
//    }
    if(ui->radioTxt2->isChecked()){
        titre_contenu_partiel=ui->contenupanel2->toPlainText();
        titre_contenu_partiel=titre_contenu_partiel.replace("","&eacute;");
        titre_contenu_partiel=titre_contenu_partiel.replace("","&egrave;");
        contenu2=titre_contenu_partiel.replace("","&agrave;").toUtf8();
    } else if(ui->radioImg2->isChecked()){

        QFileInfo infos(ui->lineEditImg2->text());
        contenu2="<div align='center'><img src='"+infos.fileName()+"'></div>";

        QFile sourceFile(ui->lineEditImg2->text());
        sourceFile.open(QIODevice::ReadOnly);

        QFile destFile(infos.fileName());
        destFile.open(QIODevice::WriteOnly);

        destFile.write(sourceFile.readAll());
        sourceFile.close();
        destFile.close();

}


    if(ui->radioTxt3->isChecked()){
        titre_contenu_partiel=ui->contenupanel3->toPlainText();
        titre_contenu_partiel=titre_contenu_partiel.replace("","&eacute;");
        titre_contenu_partiel=titre_contenu_partiel.replace("","&egrave;");
        contenu3=titre_contenu_partiel.replace("","&agrave;").toUtf8();
    } else if(ui->radioImg3->isChecked()){

        QFileInfo infos(ui->lineEditImg3->text());
        contenu3="<div align='center'><img src='"+infos.fileName()+"'></div>";

        QFile sourceFile(ui->lineEditImg3->text());
        sourceFile.open(QIODevice::ReadOnly);

        QFile destFile(infos.fileName());
        destFile.open(QIODevice::WriteOnly);

        destFile.write(sourceFile.readAll());
        sourceFile.close();
        destFile.close();

}

    if(ui->radioTxt4->isChecked()){
        titre_contenu_partiel=ui->contenupanel4->toPlainText();
        titre_contenu_partiel=titre_contenu_partiel.replace("","&eacute;");
        titre_contenu_partiel=titre_contenu_partiel.replace("","&egrave;");
        contenu4=titre_contenu_partiel.replace("","&agrave;").toUtf8();
    } else if(ui->radioImg4->isChecked()){

        QFileInfo infos(ui->lineEditImg4->text());
        contenu4="<div align='center'><img src='"+infos.fileName()+"'></div>";

        QFile sourceFile(ui->lineEditImg4->text());
        sourceFile.open(QIODevice::ReadOnly);

        QFile destFile(infos.fileName());
        destFile.open(QIODevice::WriteOnly);

        destFile.write(sourceFile.readAll());
        sourceFile.close();
        destFile.close();

}

}

void MainWindow::on_autoslide_stateChanged(int arg1)
{

    recuperation_etat_proprietes();

    string contenu_temp;

        if(arg1==Qt::Checked){

            contenu_temp=propbool->checkAutoSlideState(true);
            contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
            contenu_temp=propbool->checkDynamicTabsState(choix_tabsauto,contenu_temp);
            contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
            contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
            contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);

            contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
            contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
            contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
            contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

            contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
            contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

            contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
            contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

            contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

            enregistrement_fichier(contenu_temp);

            lancer_preview();

        } else if(arg1==Qt::Unchecked){

            contenu_temp=propbool->checkAutoSlideState(false);
            contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
            contenu_temp=propbool->checkDynamicTabsState(choix_tabsauto,contenu_temp);
            contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
            contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
            contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);

            contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
            contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
            contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
            contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

            contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
            contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

            contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
            contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

            contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

            enregistrement_fichier(contenu_temp);

            lancer_preview();
        }
}

void MainWindow::on_defil_fleche_stateChanged(int arg1)
{

    recuperation_etat_proprietes();

    string contenu_temp;

        if(arg1==Qt::Checked){

            contenu_temp=propbool->checkAutoSlideState(choix_slide);
            contenu_temp=propbool->checkDefilAutoState(true,contenu_temp);
            contenu_temp=propbool->checkDynamicTabsState(choix_tabsauto,contenu_temp);
            contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
            contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
            contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);

            contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
            contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
            contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
            contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

            contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
            contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

            contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
            contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

            contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

            enregistrement_fichier(contenu_temp);

            lancer_preview();

        } else if(arg1==Qt::Unchecked){


            contenu_temp=propbool->checkAutoSlideState(choix_slide);
            contenu_temp=propbool->checkDefilAutoState(false,contenu_temp);
            contenu_temp=propbool->checkDynamicTabsState(choix_tabsauto,contenu_temp);
            contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
            contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
            contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);

            contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
            contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
            contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
            contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

            contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
            contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

            contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
            contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

            contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

            enregistrement_fichier(contenu_temp);

            lancer_preview();

        }
}


void MainWindow::on_tabsdyn_stateChanged(int arg1)
{

    recuperation_etat_proprietes();

    string contenu_temp;

        if(arg1==Qt::Checked){

            contenu_temp=propbool->checkAutoSlideState(choix_slide);
            contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
            contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
            contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
            contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);
            contenu_temp=propbool->checkDynamicTabsState(true,contenu_temp);

            contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
            contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
            contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
            contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

            contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
            contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

            contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
            contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

            contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

            enregistrement_fichier(contenu_temp);

            lancer_preview();

        } else if(arg1==Qt::Unchecked){

            contenu_temp=propbool->checkAutoSlideState(choix_slide);
            contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
            contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
            contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
            contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);
            contenu_temp=propbool->checkDynamicTabsState(false,contenu_temp);

            contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
            contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
            contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
            contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

            contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
            contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

            contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
            contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

            contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

            enregistrement_fichier(contenu_temp);

            lancer_preview();

        }

}


void MainWindow::on_autoheight_stateChanged(int arg1)
{

    recuperation_etat_proprietes();

    string contenu_temp;

        if(arg1==Qt::Checked){

            contenu_temp=propbool->checkAutoSlideState(choix_slide);
            contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
            contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
            contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
            contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);
            contenu_temp=propbool->checkAutoHeightState(true,contenu_temp);

            contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
            contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
            contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
            contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

            contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
            contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

            contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
            contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

            contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

            enregistrement_fichier(contenu_temp);

            lancer_preview();

        } else if(arg1==Qt::Unchecked){

            contenu_temp=propbool->checkAutoSlideState(choix_slide);
            contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
            contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
            contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
            contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);
            contenu_temp=propbool->checkAutoHeightState(false,contenu_temp);

            contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
            contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
            contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
            contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

            contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
            contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

            contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
            contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

            contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

            enregistrement_fichier(contenu_temp);

            lancer_preview();

        }

}

void MainWindow::on_stopslideonclic_stateChanged(int arg1)
{


    recuperation_etat_proprietes();

    string contenu_temp;

        if(arg1==Qt::Checked){

            contenu_temp=propbool->checkAutoSlideState(choix_slide);
            contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
            contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
            contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
            contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);
            contenu_temp=propbool->checkSlideStopOnClicState(true,contenu_temp);

            contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
            contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
            contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
            contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

            contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
            contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

            contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
            contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

            contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

            enregistrement_fichier(contenu_temp);

            lancer_preview();

        } else if(arg1==Qt::Unchecked){

            contenu_temp=propbool->checkAutoSlideState(choix_slide);
            contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
            contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
            contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
            contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);
            contenu_temp=propbool->checkSlideStopOnClicState(false,contenu_temp);

            contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
            contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
            contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
            contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

            contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
            contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

            contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
            contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

            contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

            enregistrement_fichier(contenu_temp);

            lancer_preview();

        }
}

void MainWindow::on_crosslinking_stateChanged(int arg1)
{

    recuperation_etat_proprietes();

    string contenu_temp;

        if(arg1==Qt::Checked){

            contenu_temp=propbool->checkAutoSlideState(choix_slide);
            contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
            contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
            contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
            contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
            contenu_temp=propbool->checkCrossLinkingState(true,contenu_temp);

            contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
            contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
            contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
            contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

            contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
            contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

            contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
            contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

            contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

            enregistrement_fichier(contenu_temp);

            lancer_preview();

        } else if(arg1==Qt::Unchecked){

            contenu_temp=propbool->checkAutoSlideState(choix_slide);
            contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
            contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
            contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
            contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
            contenu_temp=propbool->checkCrossLinkingState(false,contenu_temp);

            contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
            contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
            contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
            contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

            contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
            contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
            contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

            contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
            contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

            contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
            contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

            enregistrement_fichier(contenu_temp);

            lancer_preview();

        }

}



void MainWindow::on_dureeanim_valueChanged(int value)
{
    if(value!=0){

        recuperation_etat_proprietes();

        string contenu_temp;

        contenu_temp=propbool->checkAutoSlideState(choix_slide);
        contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
        contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
        contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
        contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
        contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);

        contenu_temp=propnum->recupDureeAnimationValeur(value,contenu_temp);
        contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
        contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
        contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

        contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
        contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

        contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
        contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

        contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

        enregistrement_fichier(contenu_temp);

        lancer_preview();
    }
}

void MainWindow::on_firstslide_valueChanged(int value)
{
    if(value!=0){

        recuperation_etat_proprietes();

        string contenu_temp;

        contenu_temp=propbool->checkAutoSlideState(choix_slide);
        contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
        contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
        contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
        contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
        contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);

        contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
        contenu_temp=propnum->recupPremierPanelValeur(value,contenu_temp);
        contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
        contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

        contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
        contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

        contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
        contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

        contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

        enregistrement_fichier(contenu_temp);

        lancer_preview();
    }

}

void MainWindow::on_slideinterval_valueChanged(int value)
{
    if(value!=0){

        recuperation_etat_proprietes();

        string contenu_temp;

        contenu_temp=propbool->checkAutoSlideState(choix_slide);
        contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
        contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
        contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
        contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
        contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);

        contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
        contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
        contenu_temp=propnum->recupTempsTransitionEntreSlides(value,contenu_temp);
        contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

        contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
        contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

        contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
        contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

        contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

        enregistrement_fichier(contenu_temp);

        lancer_preview();
    }
}

void MainWindow::on_dureeanimhauteur_valueChanged(int value)
{
    if(value!=0){

        recuperation_etat_proprietes();

        string contenu_temp;

        contenu_temp=propbool->checkAutoSlideState(choix_slide);
        contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
        contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
        contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
        contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
        contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);

        contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
        contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
        contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
        contenu_temp=propnum->recupDureeAnimationHauteur(value,contenu_temp);

        contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
        contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

        contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
        contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

        contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

        enregistrement_fichier(contenu_temp);

        lancer_preview();
    }

}

void MainWindow::on_poshorizontale_currentIndexChanged(const QString &arg1)
{
    if(arg1.length()!=0){

        recuperation_etat_proprietes();

        string contenu_temp;

        contenu_temp=propbool->checkAutoSlideState(choix_slide);
        contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
        contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
        contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
        contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
        contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);

        contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
        contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
        contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
        contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

        contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
        contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsAlignValeur(arg1.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

        contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
        contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

        contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

        enregistrement_fichier(contenu_temp);

        lancer_preview();
    }
}

void MainWindow::on_posverticale_currentIndexChanged(const QString &arg1)
{
    if(arg1.length()!=0){

        recuperation_etat_proprietes();

        string contenu_temp;

        contenu_temp=propbool->checkAutoSlideState(choix_slide);
        contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
        contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
        contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
        contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
        contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);

        contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
        contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
        contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
        contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

        contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
        contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsPositionValeur(arg1.toStdString(),contenu_temp);

        contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
        contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

        contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

        enregistrement_fichier(contenu_temp);

        lancer_preview();
    }
}

void MainWindow::on_typeanimhauteur_currentIndexChanged(const QString &arg1)
{
    if(arg1.length()!=0){

        recuperation_etat_proprietes();

        string contenu_temp;

        contenu_temp=propbool->checkAutoSlideState(choix_slide);
        contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
        contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
        contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
        contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
        contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);

        contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
        contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
        contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
        contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

        contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
        contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

        contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(arg1.toStdString(),contenu_temp);
        contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

        contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

        enregistrement_fichier(contenu_temp);

        lancer_preview();
    }

}

void MainWindow::on_transitionslides_currentIndexChanged(const QString &arg1)
{
    if(arg1.length()!=0){

        recuperation_etat_proprietes();

        string contenu_temp;

        contenu_temp=propbool->checkAutoSlideState(choix_slide);
        contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
        contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
        contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
        contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
        contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);

        contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
        contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
        contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
        contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

        contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
        contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
        contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

        contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
        contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(arg1.toStdString(),contenu_temp);

        contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
        contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

        enregistrement_fichier(contenu_temp);

        lancer_preview();
    }

}


void MainWindow::on_actualisation_clicked()
{
    //ui->previewWebView->load(QUrl("default.html"));
    recuperation_etat_proprietes();

    string contenu_temp;

    contenu_temp=propbool->checkAutoSlideState(choix_slide);
    contenu_temp=propbool->checkDefilAutoState(choix_fleche,contenu_temp);
    contenu_temp=propbool->checkDynamicTabsState(choix_tabsdyn,contenu_temp);
    contenu_temp=propbool->checkAutoHeightState(choix_autoheight,contenu_temp);
    contenu_temp=propbool->checkSlideStopOnClicState(choix_slidestoponclic,contenu_temp);
    contenu_temp=propbool->checkCrossLinkingState(choix_crosslinking,contenu_temp);

    contenu_temp=propnum->recupDureeAnimationValeur(val_duree_anim,contenu_temp);
    contenu_temp=propnum->recupPremierPanelValeur(val_premier_slide,contenu_temp);
    contenu_temp=propnum->recupTempsTransitionEntreSlides(val_slide_interval,contenu_temp);
    contenu_temp=propnum->recupDureeAnimationHauteur(val_duree_anim_hauteur,contenu_temp);

    contenu_temp=proppos->recupLeftTextValeur(val_texte_fleche_gauche.toStdString(),contenu_temp);
    contenu_temp=proppos->recupRightTextValeur(val_texte_fleche_droite.toStdString(),contenu_temp);
    contenu_temp=proppos->recupDynamicTabsAlignValeur(val_texte_tabs_align.toStdString(),contenu_temp);
    contenu_temp=proppos->recupDynamicTabsPositionValeur(val_texte_tabs_position.toStdString(),contenu_temp);

    contenu_temp=proptypeslide->recupTypeAnimHauteurValeur(val_type_anim_hauteur.toStdString(),contenu_temp);
    contenu_temp=proptypeslide->recupTypeAnimTransitionValeur(val_type_anim_transition.toStdString(),contenu_temp);

    contenu_temp=contslides->recupTitre1Valeur(titre1.toStdString(),contenu_temp);
    contenu_temp=contslides->recupTitre2Valeur(titre2.toStdString(),contenu_temp);
    contenu_temp=contslides->recupTitre3Valeur(titre3.toStdString(),contenu_temp);
    contenu_temp=contslides->recupTitre4Valeur(titre4.toStdString(),contenu_temp);
    contenu_temp=contslides->recupContenu1Valeur(contenu1.toStdString(),contenu_temp);
    contenu_temp=contslides->recupContenu2Valeur(contenu2.toStdString(),contenu_temp);
    contenu_temp=contslides->recupContenu3Valeur(contenu3.toStdString(),contenu_temp);
    contenu_temp=contslides->recupContenu4Valeur(contenu4.toStdString(),contenu_temp);

    enregistrement_fichier(contenu_temp);

    lancer_preview();
}


void MainWindow::on_radioImg1_stateChanged(int arg1)
{
    if(arg1==Qt::Checked){
      //-----------activation du champ de l'image----------
        ui->boutimg1->setEnabled(true);
        ui->lineEditImg1->setEnabled(true);
        if(ui->radioTxt1->isChecked()){
            ui->radioTxt1->setChecked(false);
        }

     //-----------dsactivation du champ de texte----------
        ui->contenupanel1->setEnabled(false);
        if(ui->radioImg1->isChecked()==false){
            ui->radioImg1->setChecked(true);
        }



    } else if(arg1==Qt::Unchecked){
    //-----------dsactivation du champ de l'image----------
        ui->boutimg1->setEnabled(false);
        ui->lineEditImg1->setEnabled(false);
        if(ui->radioTxt1->isChecked()==false){
            ui->radioTxt1->setChecked(true);
        }
    //-----------activation du champ de texte----------
        ui->contenupanel1->setEnabled(true);
        if(ui->radioImg1->isChecked()){
            ui->radioImg1->setChecked(false);
        }


    }
}

void MainWindow::on_radioTxt1_stateChanged(int arg1)
{
    if(arg1==Qt::Checked){
        //-----------activation du champ de texte----------
        ui->contenupanel1->setEnabled(true);
        if(ui->radioImg1->isChecked()){
            ui->radioImg1->setChecked(false);
        }

        //-----------dsactivation du champ de l'image----------
        ui->boutimg1->setEnabled(false);
        ui->lineEditImg1->setEnabled(false);
        if(ui->radioTxt1->isChecked()==false){
            ui->radioTxt1->setChecked(true);
        }

    } else if(arg1==Qt::Unchecked){
        //-----------dsactivation du champ de texte----------
        ui->contenupanel1->setEnabled(false);
        if(ui->radioImg1->isChecked()==false){
            ui->radioImg1->setChecked(true);
        }

        //-----------activation du champ de l'image----------
        ui->boutimg1->setEnabled(true);
        ui->lineEditImg1->setEnabled(true);
        if(ui->radioTxt1->isChecked()){
            ui->radioTxt1->setChecked(false);
        }


    }

}

void MainWindow::on_radioTxt2_stateChanged(int arg1)
{
    if(arg1==Qt::Checked){
        //-----------activation du champ de texte----------
        ui->contenupanel2->setEnabled(true);
        if(ui->radioImg2->isChecked()){
            ui->radioImg2->setChecked(false);
        }

        //-----------dsactivation du champ de l'image----------
        ui->boutimg2->setEnabled(false);
        ui->lineEditImg2->setEnabled(false);
        if(ui->radioTxt2->isChecked()==false){
            ui->radioTxt2->setChecked(true);
        }

    } else if(arg1==Qt::Unchecked){
        //-----------dsactivation du champ de texte----------
        ui->contenupanel2->setEnabled(false);
        if(ui->radioImg2->isChecked()==false){
            ui->radioImg2->setChecked(true);
        }

        //-----------activation du champ de l'image----------
        ui->boutimg2->setEnabled(true);
        ui->lineEditImg2->setEnabled(true);
        if(ui->radioTxt2->isChecked()){
            ui->radioTxt2->setChecked(false);
        }


    }

}

void MainWindow::on_radioImg2_stateChanged(int arg1)
{
    if(arg1==Qt::Checked){
      //-----------activation du champ de l'image----------
        ui->boutimg2->setEnabled(true);
        ui->lineEditImg2->setEnabled(true);
        if(ui->radioTxt2->isChecked()){
            ui->radioTxt2->setChecked(false);
        }

     //-----------dsactivation du champ de texte----------
        ui->contenupanel2->setEnabled(false);
        if(ui->radioImg2->isChecked()==false){
            ui->radioImg2->setChecked(true);
        }



    } else if(arg1==Qt::Unchecked){
    //-----------dsactivation du champ de l'image----------
        ui->boutimg2->setEnabled(false);
        ui->lineEditImg2->setEnabled(false);
        if(ui->radioTxt2->isChecked()==false){
            ui->radioTxt2->setChecked(true);
        }
    //-----------activation du champ de texte-----------
        ui->contenupanel2->setEnabled(true);
        if(ui->radioImg2->isChecked()){
            ui->radioImg2->setChecked(false);
        }


    }

}

void MainWindow::on_radioTxt3_stateChanged(int arg1)
{
    if(arg1==Qt::Checked){
        //-----------activation du champ de texte----------
        ui->contenupanel3->setEnabled(true);
        if(ui->radioImg3->isChecked()){
            ui->radioImg3->setChecked(false);
        }

        //-----------dsactivation du champ de l'image----------
        ui->boutimg3->setEnabled(false);
        ui->lineEditImg3->setEnabled(false);
        if(ui->radioTxt3->isChecked()==false){
            ui->radioTxt3->setChecked(true);
        }

    } else if(arg1==Qt::Unchecked){
        //-----------dsactivation du champ de texte----------
        ui->contenupanel3->setEnabled(false);
        if(ui->radioImg3->isChecked()==false){
            ui->radioImg3->setChecked(true);
        }

        //-----------activation du champ de l'image----------
        ui->boutimg3->setEnabled(true);
        ui->lineEditImg3->setEnabled(true);
        if(ui->radioTxt3->isChecked()){
            ui->radioTxt3->setChecked(false);
        }


    }

}

void MainWindow::on_radioImg3_stateChanged(int arg1)
{
    if(arg1==Qt::Checked){
      //-----------activation du champ de l'image----------
        ui->boutimg3->setEnabled(true);
        ui->lineEditImg3->setEnabled(true);
        if(ui->radioTxt3->isChecked()){
            ui->radioTxt3->setChecked(false);
        }

     //-----------dsactivation du champ de texte----------
        ui->contenupanel3->setEnabled(false);
        if(ui->radioImg3->isChecked()==false){
            ui->radioImg3->setChecked(true);
        }



    } else if(arg1==Qt::Unchecked){
    //-----------dsactivation du champ de l'image----------
        ui->boutimg3->setEnabled(false);
        ui->lineEditImg3->setEnabled(false);
        if(ui->radioTxt3->isChecked()==false){
            ui->radioTxt3->setChecked(true);
        }
    //-----------activation du champ de texte-----------
        ui->contenupanel3->setEnabled(true);
        if(ui->radioImg3->isChecked()){
            ui->radioImg3->setChecked(false);
        }


    }
}

void MainWindow::on_radioTxt4_stateChanged(int arg1)
{
    if(arg1==Qt::Checked){
        //-----------activation du champ de texte----------
        ui->contenupanel4->setEnabled(true);
        if(ui->radioImg4->isChecked()){
            ui->radioImg4->setChecked(false);
        }

        //-----------dsactivation du champ de l'image----------
        ui->boutimg4->setEnabled(false);
        ui->lineEditImg4->setEnabled(false);
        if(ui->radioTxt4->isChecked()==false){
            ui->radioTxt4->setChecked(true);
        }

    } else if(arg1==Qt::Unchecked){
        //-----------dsactivation du champ de texte----------
        ui->contenupanel4->setEnabled(false);
        if(ui->radioImg4->isChecked()==false){
            ui->radioImg4->setChecked(true);
        }

        //-----------activation du champ de l'image----------
        ui->boutimg4->setEnabled(true);
        ui->lineEditImg4->setEnabled(true);
        if(ui->radioTxt4->isChecked()){
            ui->radioTxt4->setChecked(false);
        }


    }
}

void MainWindow::on_radioImg4_stateChanged(int arg1)
{
    if(arg1==Qt::Checked){
      //-----------activation du champ de l'image----------
        ui->boutimg4->setEnabled(true);
        ui->lineEditImg4->setEnabled(true);
        if(ui->radioTxt4->isChecked()){
            ui->radioTxt4->setChecked(false);
        }

     //-----------dsactivation du champ de texte----------
        ui->contenupanel4->setEnabled(false);
        if(ui->radioImg4->isChecked()==false){
            ui->radioImg4->setChecked(true);
        }



    } else if(arg1==Qt::Unchecked){
    //-----------dsactivation du champ de l'image----------
        ui->boutimg4->setEnabled(false);
        ui->lineEditImg4->setEnabled(false);
        if(ui->radioTxt4->isChecked()==false){
            ui->radioTxt4->setChecked(true);
        }
    //-----------activation du champ de texte-----------
        ui->contenupanel4->setEnabled(true);
        if(ui->radioImg4->isChecked()){
            ui->radioImg4->setChecked(false);
        }


    }
}

void MainWindow::on_boutimg1_clicked()
{
    QString cheminFichier=QFileDialog::getOpenFileName(this,tr("Choisir une image"),".",tr("Fichiers images (*.jpg; *.png; *.gif)"));
    ui->lineEditImg1->setText(cheminFichier);
}

void MainWindow::on_boutimg2_clicked()
{
    QString cheminFichier=QFileDialog::getOpenFileName(this,tr("Choisir une image"),".",tr("Fichiers images (*.jpg; *.png; *.gif)"));
    ui->lineEditImg2->setText(cheminFichier);
}

void MainWindow::on_boutimg3_clicked()
{
    QString cheminFichier=QFileDialog::getOpenFileName(this,tr("Choisir une image"),".",tr("Fichiers images (*.jpg; *.png; *.gif)"));
    ui->lineEditImg3->setText(cheminFichier);
}

void MainWindow::on_boutimg4_clicked()
{
    QString cheminFichier=QFileDialog::getOpenFileName(this,tr("Choisir une image"),".",tr("Fichiers images (*.jpg; *.png; *.gif)"));
    ui->lineEditImg4->setText(cheminFichier);
}

void MainWindow::on_copier_code_insert_clicked()
{
    const int longueur_COMMENT_END_JAVASCRIPT=23;
    const int longueur_COMMENT_CODA_SLIDER_WRAPPER=29;

    string ligne;
    string contenu;

    ifstream in("default.html");

    while(getline(in,ligne)){
        contenu+=ligne+"\n";
    }
    in.close();

    //-------------Extration du contenu  insrer dans head--------------------------
    int pos=contenu.find("<!-- Begin Stylesheets -->");
    int pos2=contenu.find("<!-- End JavaScript -->");
    string contenu_head=contenu.substr(pos,(pos2-pos)+longueur_COMMENT_END_JAVASCRIPT);
    //-------------Extration du contenu  insrer dans body--------------------------
    pos=contenu.find("<noscript>");
    pos2=contenu.find("<!-- .coda-slider-wrapper -->");

    string contenu_body=contenu.substr(pos,(pos2-pos)+longueur_COMMENT_CODA_SLIDER_WRAPPER);


    //ui_dialog_code_a_copier=new CodeACopier(this);
    ui_dialog_code_a_copier->insertion_head_body(contenu_head,contenu_body);

    ui_dialog_code_a_copier->show();
    ui_dialog_code_a_copier->raise();
    ui_dialog_code_a_copier->activateWindow();

}
