/*
Cr par Eric Dodji Gbofu
Email: dodericg@yahoo.fr
Twitter: @doderic
Blog: http://doderic.wordpress.com
Site: http://www.yatasoft.com
Dcembre 2011
*/
#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include "ui_SlideAlways.h"
#include "codeacopier.h"
#include <QtGui>
#include <string>

using namespace std;

class PropBool;
class PropNum;
class PropPos;
class PropTypeSlide;
class ContenusSlide;
class CodeACopier;


class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

private slots:
    void on_autoslide_stateChanged(int arg1);
    void on_defil_fleche_stateChanged(int arg1);
    void on_tabsdyn_stateChanged(int arg1);
    void on_test_navigateur_clicked();
    void a_propos();
    void on_autoheight_stateChanged(int arg1);
    void on_stopslideonclic_stateChanged(int arg1);
    void on_crosslinking_stateChanged(int arg1);
    void on_dureeanim_valueChanged(int value);
    void on_firstslide_valueChanged(int value);
    void on_slideinterval_valueChanged(int value);
    void on_dureeanimhauteur_valueChanged(int value);

    void test_dans_navigateur();

    void on_poshorizontale_currentIndexChanged(const QString &arg1);

    void on_posverticale_currentIndexChanged(const QString &arg1);

    void on_typeanimhauteur_currentIndexChanged(const QString &arg1);

    void on_transitionslides_currentIndexChanged(const QString &arg1);
    void a_propos_codaslider();
    void export_animation();
    void lancer_site_de_slidealways();
    void enregistrer_projet_sous();
    void enregistrer_projet();
    void ouvrir_projet();

    void on_actualisation_clicked();


    void on_radioImg1_stateChanged(int arg1);

    void on_radioTxt1_stateChanged(int arg1);

    void on_radioTxt2_stateChanged(int arg1);

    void on_radioImg2_stateChanged(int arg1);

    void on_radioTxt3_stateChanged(int arg1);

    void on_radioImg3_stateChanged(int arg1);

    void on_radioTxt4_stateChanged(int arg1);

    void on_radioImg4_stateChanged(int arg1);

    void on_boutimg1_clicked();

    void on_boutimg2_clicked();

    void on_boutimg3_clicked();

    void on_boutimg4_clicked();

    void on_copier_code_insert_clicked();

private:
    void lancer_preview();
    void enregistrement_fichier(string contenu);
    void recuperation_etat_proprietes();
    void enregistrement_projet(QString nomFichier);




    Ui::MainWindow *ui;
    CodeACopier *ui_dialog_code_a_copier;
    QString nom_fichier;
    QString fichier_courant;

    PropBool *propbool;
    PropNum *propnum;
    PropPos *proppos;
    PropTypeSlide *proptypeslide;
    ContenusSlide *contslides;


    //---------variables de rcupration des tats des proprits---------------------
    bool choix_slide;
    bool choix_fleche;
    bool choix_tabsdyn;
    bool choix_autoheight;
    bool choix_slidestoponclic;
    bool choix_tabsauto;
    bool choix_crosslinking;

    int val_duree_anim;
    int val_premier_slide;
    int val_slide_interval;
    int val_duree_anim_hauteur;

    QString val_texte_fleche_gauche;
    QString val_texte_fleche_droite;
    QString val_texte_tabs_align;
    QString val_texte_tabs_position;

    QString val_type_anim_hauteur;
    QString val_type_anim_transition;

    QString titre1;
    QString titre2;
    QString titre3;
    QString titre4;
    QString contenu1;
    QString contenu2;
    QString contenu3;
    QString contenu4;


};

#endif // MAINWINDOW_H
